//
// LoadObjFile.cpp
//
#include "stdafx.h"

#include "Model.h"

#define NONAME	"(NoName)"
#define	READSTRINGBUFFERLEN	256

CMaterial FindMaterial( std::vector<CMaterial> vMaterial, char* pszName )
{
	unsigned int ui;
	for( ui = 0; ui < vMaterial.size(); ui++ )
	{
		if( 0 == _stricmp( pszName, vMaterial[ui].m_strName.c_str() ) )
		{
			goto found;
		}
	}

	ui = 0;	// Ȃꍇɂ́A(NONAME)}eAɂB

found:
	return vMaterial[ui];
}

CGroup* FindGroup( CModel* pModel, char* pszName )
{
	for( unsigned int ui = 0; ui < pModel->m_vpGroup.size(); ui++ )
	{
		if( 0 == _stricmp( pszName, pModel->m_vpGroup[ui]->m_strName.c_str() ) )
		{
			return pModel->m_vpGroup[ui];
		}
	}

	return NULL;
}

CGroup* AddGroup( CModel* pModel, char* pszName )
{
	CGroup* pGroup_work = FindGroup( pModel, pszName );
	if( NULL == pGroup_work )
	{
		pGroup_work = new CGroup( pModel );
		pGroup_work->m_strName = pszName;
		pModel->m_vpGroup.push_back( pGroup_work );
	}

	return pGroup_work;
}

char* GetDirName( const char* pszPathName )
{
	char* pszDirName = _strdup( pszPathName );

	char* pszStrrchr = strrchr( pszDirName, '\\' );
	if( pszStrrchr )
	{
		pszStrrchr[1] = '\0';
	}
	else
	{
		pszDirName[0] = '\0';
	}

	return pszDirName;
}

bool LoadMtlFile( std::vector<CMaterial>& vMaterial,
	const char* pszMtlFileName,
	const char* pszObjFilePath )
{
	char*	pszDirName = GetDirName( pszObjFilePath );
	size_t uiSizeFileName = strlen( pszDirName ) + strlen( pszMtlFileName ) + 1;
	char*	pszFileName = (char*)calloc( uiSizeFileName, sizeof( char ) );
	strcpy_s( pszFileName, uiSizeFileName, pszDirName );
	strcat_s( pszFileName, uiSizeFileName, pszMtlFileName );
	free( pszDirName );

	FILE*	pFILE;
	errno_t err = fopen_s( &pFILE, pszFileName, "rt" );
	free( pszFileName );
	if( 0 != err )
	{
		return false;
	}

	while( 1 )
	{
		char	szReadString[READSTRINGBUFFERLEN];
		if( NULL == fgets( szReadString, READSTRINGBUFFERLEN, pFILE ) )
		{
			break;
		}
		const char 	cszDelimiter[] = ", \r\n\t";
		char* pszContext;
		char* pszToken = strtok_s( szReadString, cszDelimiter, &pszContext );
		if( NULL == pszToken )
		{
			continue;
		}

		char* pszTokenK;
		switch( pszToken[0] )
		{
			case '#':	// Rg
				break;
			case 'n':	// }eA
				vMaterial.push_back( CMaterial() );
				pszToken = strtok_s( NULL, "\r\n", &pszContext );
				if( NULL == pszToken )
				{
					vMaterial.back().m_strName = NONAME;
				}
				else
				{
					vMaterial.back().m_strName = pszToken;
				}
				break;
			case 'N':
				pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
				vMaterial.back().m_fShininess = (float)atof( pszToken );
				/* wavefront shininess is from [0, 1000], so scale for OpenGL */
				vMaterial.back().m_fShininess /= 1000.0;
				vMaterial.back().m_fShininess *= 128.0;
				break;
			case 'K':
				pszTokenK = strtok_s( NULL, "\r\n", &pszContext );
				switch( pszToken[1] )
				{
					case 'a':
						sscanf_s( pszTokenK, "%f %f %f", &vMaterial.back().m_f4Ambient[0],
							&vMaterial.back().m_f4Ambient[1],
							&vMaterial.back().m_f4Ambient[2] );
						break;
					case 'd':
						sscanf_s( pszTokenK, "%f %f %f", &vMaterial.back().m_f4Diffuse[0],
							&vMaterial.back().m_f4Diffuse[1],
							&vMaterial.back().m_f4Diffuse[2] );
						break;
					case 's':
						sscanf_s( pszTokenK, "%f %f %f", &vMaterial.back().m_f4Specular[0],
							&vMaterial.back().m_f4Specular[1],
							&vMaterial.back().m_f4Specular[2] );
						break;
					default:
						break;
				}
				break;
			default:
				break;
		}
	}

	fclose( pFILE );

	return true;
}

bool LoadObjFile( const char* pszFileName, CModel& model )
{
	if( NULL == pszFileName )
	{
		return false;
	}

	FILE* pFILE;
	if( 0 != fopen_s( &pFILE, pszFileName, "rt" ) )
	{
		return false;
	}

	// O[vA}eAǂݍ
	CGroup* pGroup_current = AddGroup( &model, NONAME );
	std::vector<CMaterial> vMaterial;
	vMaterial.push_back( CMaterial() );
	vMaterial.back().m_strName = NONAME;
	while( 1 )
	{
		char	szReadString[READSTRINGBUFFERLEN];
		if( NULL == fgets( szReadString, READSTRINGBUFFERLEN, pFILE ) )
		{
			break;
		}
		const char 	cszDelimiter[] = ", \r\n\t";
		char* pszContext;
		char* pszToken = strtok_s( szReadString, cszDelimiter, &pszContext );
		if( NULL == pszToken )
		{
			continue;
		}

		switch( pszToken[0] )
		{
			case 'm':
				pszToken = strtok_s( NULL, "\r\n", &pszContext );
				LoadMtlFile( vMaterial, pszToken, pszFileName );
				break;
			case 'g':				/* group */
				pszToken = strtok_s( NULL, "\r\n", &pszContext );
				if( NULL == pszToken )
				{
					AddGroup( &model, NONAME );
				}
				else
				{
					AddGroup( &model, pszToken );
				}
				break;
		}
	}
	rewind( pFILE );

	pGroup_current = FindGroup( &model, NONAME );

	while( 1 )
	{
		char	szReadString[READSTRINGBUFFERLEN];
		if( NULL == fgets( szReadString, READSTRINGBUFFERLEN, pFILE ) )
		{
			break;
		}
		const char 	cszDelimiter[] = ", \r\n\t";
		char* pszContext;
		char* pszToken = strtok_s( szReadString, cszDelimiter, &pszContext );
		if( NULL == pszToken )
		{
			continue;
		}

		char*	pszTokenV;
		CGroup* pGroup_back;
		CVector vertex;
		CVector normalvector;
		CIndexedTriangle	indexedtriangle;
		CIndexedTriangle	indexedtriangle_back;
		switch( pszToken[0] )
		{
			case '#':				/* comment */
				break;
			case 'v':				/* v, vn, vt */
				pszTokenV = strtok_s( NULL, "\r\n", &pszContext );
				switch( pszToken[1] )
				{
					case '\0':			/* vertex */
						sscanf_s( pszTokenV, "%f %f %f", &vertex.x,
							&vertex.y,
							&vertex.z );
						model.m_vVertex.push_back( vertex );
						break;
					case 'n':				/* normal */
						sscanf_s( pszTokenV, "%f %f %f", &normalvector.x,
							&normalvector.y,
							&normalvector.z );
						model.m_vVectorVertexNormal.push_back( normalvector );
						break;
					case 't':				/* texcoord */
						break;
					default:
						return false;
				}
				break;
			case 'u':
				pszToken = strtok_s( NULL, "\r\n", &pszContext );
				pGroup_current->m_material = FindMaterial( vMaterial, pszToken );
				break;
			case 'g':				/* group */
				pszToken = strtok_s( NULL, "\r\n", &pszContext );
				pGroup_back = pGroup_current;
				if( NULL == pszToken )
				{
					pGroup_current = FindGroup( &model, NONAME );
				}
				else
				{
					pGroup_current = FindGroup( &model, pszToken );
				}
				pGroup_current->m_material = pGroup_back->m_material;
				break;
			case 'f':				/* face */
				{
					unsigned int v = 0;
					unsigned int n = 0;
					unsigned int t = 0;
					pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
					/* can be one of %d, %d//%d, %d/%d, %d/%d/%d %d//%d */
					if( strstr( pszToken, "//" ) )
					{	/* v//n */
						sscanf_s( pszToken, "%d//%d", &v, &n );
						indexedtriangle = CIndexedTriangle();	// 
						indexedtriangle.m_ui3IndexVertex[0] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[0] = n - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d//%d", &v, &n );
						indexedtriangle.m_ui3IndexVertex[1] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[1] = n - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d//%d", &v, &n );
						indexedtriangle.m_ui3IndexVertex[2] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[2] = n - 1;
						pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
						model.m_vIndexedTriangle.push_back( indexedtriangle );
						while( NULL != ( pszToken = strtok_s( NULL, cszDelimiter, &pszContext ) ) )
						{
							sscanf_s( pszToken, "%d//%d", &v, &n );
							indexedtriangle_back = indexedtriangle;
							indexedtriangle = CIndexedTriangle();	// 
							indexedtriangle.m_ui3IndexVertex[0] = indexedtriangle_back.m_ui3IndexVertex[0];
							indexedtriangle.m_ui3IndexVertexNormal[0] = indexedtriangle_back.m_ui3IndexVertexNormal[0];
							indexedtriangle.m_ui3IndexVertex[1] = indexedtriangle_back.m_ui3IndexVertex[2];
							indexedtriangle.m_ui3IndexVertexNormal[1] = indexedtriangle_back.m_ui3IndexVertexNormal[2];
							indexedtriangle.m_ui3IndexVertex[2] = v - 1;
							indexedtriangle.m_ui3IndexVertexNormal[2] = n - 1;
							pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
							model.m_vIndexedTriangle.push_back( indexedtriangle );
						}
					}
					else if( 3 == sscanf_s( pszToken, "%d/%d/%d", &v, &t, &n ) )
					{	/* v/t/n */
						indexedtriangle = CIndexedTriangle();	// 
						indexedtriangle.m_ui3IndexVertex[0] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[0] = n - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d/%d/%d", &v, &t, &n );
						indexedtriangle.m_ui3IndexVertex[1] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[1] = n - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d/%d/%d", &v, &t, &n );
						indexedtriangle.m_ui3IndexVertex[2] = v - 1;
						indexedtriangle.m_ui3IndexVertexNormal[2] = n - 1;
						pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
						model.m_vIndexedTriangle.push_back( indexedtriangle );
						while( NULL != ( pszToken = strtok_s( NULL, cszDelimiter, &pszContext ) ) )
						{
							sscanf_s( pszToken, "%d/%d/%d", &v, &t, &n );
							indexedtriangle_back = indexedtriangle;
							indexedtriangle = CIndexedTriangle();	// 
							indexedtriangle.m_ui3IndexVertex[0] = indexedtriangle_back.m_ui3IndexVertex[0];
							indexedtriangle.m_ui3IndexVertexNormal[0] = indexedtriangle_back.m_ui3IndexVertexNormal[0];
							indexedtriangle.m_ui3IndexVertex[1] = indexedtriangle_back.m_ui3IndexVertex[2];
							indexedtriangle.m_ui3IndexVertexNormal[1] = indexedtriangle_back.m_ui3IndexVertexNormal[2];
							indexedtriangle.m_ui3IndexVertex[2] = v - 1;
							indexedtriangle.m_ui3IndexVertexNormal[2] = n - 1;
							pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
							model.m_vIndexedTriangle.push_back( indexedtriangle );
						}
					}
					else if( 2 == sscanf_s( pszToken, "%d/%d", &v, &t ) )
					{	/* v/t */
						indexedtriangle = CIndexedTriangle();	// 
						indexedtriangle.m_ui3IndexVertex[0] = v - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d/%d", &v, &t );
						indexedtriangle.m_ui3IndexVertex[1] = v - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d/%d", &v, &t );
						indexedtriangle.m_ui3IndexVertex[2] = v - 1;
						pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
						model.m_vIndexedTriangle.push_back( indexedtriangle );
						while( NULL != ( pszToken = strtok_s( NULL, cszDelimiter, &pszContext ) ) )
						{
							sscanf_s( pszToken, "%d/%d", &v, &t );
							indexedtriangle_back = indexedtriangle;
							indexedtriangle = CIndexedTriangle();	// 
							indexedtriangle.m_ui3IndexVertex[0] = indexedtriangle_back.m_ui3IndexVertex[0];
							indexedtriangle.m_ui3IndexVertex[1] = indexedtriangle_back.m_ui3IndexVertex[2];
							indexedtriangle.m_ui3IndexVertex[2] = v - 1;
							pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
							model.m_vIndexedTriangle.push_back( indexedtriangle );
						}
					}
					else
					{	/* v */
						sscanf_s( pszToken, "%d", &v );
						indexedtriangle = CIndexedTriangle();	// 
						indexedtriangle.m_ui3IndexVertex[0] = v - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d", &v );
						indexedtriangle.m_ui3IndexVertex[1] = v - 1;
						pszToken = strtok_s( NULL, cszDelimiter, &pszContext );
						sscanf_s( pszToken, "%d", &v );
						indexedtriangle.m_ui3IndexVertex[2] = v - 1;
						pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
						model.m_vIndexedTriangle.push_back( indexedtriangle );
						while( NULL != ( pszToken = strtok_s( NULL, cszDelimiter, &pszContext ) ) )
						{
							sscanf_s( pszToken, "%d", &v );
							indexedtriangle_back = indexedtriangle;
							indexedtriangle = CIndexedTriangle();	// 
							indexedtriangle.m_ui3IndexVertex[0] = indexedtriangle_back.m_ui3IndexVertex[0];
							indexedtriangle.m_ui3IndexVertex[1] = indexedtriangle_back.m_ui3IndexVertex[2];
							indexedtriangle.m_ui3IndexVertex[2] = v - 1;
							pGroup_current->m_vuiIndexIndexedTriangle.push_back( (unsigned int)model.m_vIndexedTriangle.size() );
							model.m_vIndexedTriangle.push_back( indexedtriangle );
						}
					}
				}
				break;
			default:
				break;
		}
	}

	fclose( pFILE );

	if( 0 == model.m_vVertex.size()
		|| 0 == model.m_vIndexedTriangle.size() )
	{
		return false;
	}

	return true;
}
