//
// Model.h
//
#pragma once

#include <vector>

class CVector
{
public:
	float	x, y, z;
public:
	CVector( float a = 0.0, float b = 0.0, float c = 0.0 ) : x(a), y(b), z(c) {}
};

class CIndexedTriangle
{
public:
	unsigned int m_ui3IndexVertex[3];			// _ԍ
	unsigned int m_ui3IndexVertexNormal[3];	// _@ԍ
public:
	CIndexedTriangle()
	{
		m_ui3IndexVertex[0] = -1;
		m_ui3IndexVertex[1] = -1;
		m_ui3IndexVertex[2] = -1;
		m_ui3IndexVertexNormal[0] = -1;
		m_ui3IndexVertexNormal[1] = -1;
		m_ui3IndexVertexNormal[2] = -1;
	}
};

class CMaterial
{
public:
	CMaterial()
	{
		m_f4Ambient[0] = 0.2f;
		m_f4Ambient[1] = 0.2f;
		m_f4Ambient[2] = 0.2f;
		m_f4Ambient[3] = 1.0f;
		m_f4Diffuse[0] = 0.8f;
		m_f4Diffuse[1] = 0.8f;
		m_f4Diffuse[2] = 0.8f;
		m_f4Diffuse[3] = 1.0f;
		m_f4Specular[0] = 0.0f;
		m_f4Specular[1] = 0.0f;
		m_f4Specular[2] = 0.0f;
		m_f4Specular[3] = 1.0f;
		m_fShininess = 0.0f;
	}
public:
	float	m_f4Ambient[4];
	float	m_f4Diffuse[4];
	float	m_f4Specular[4];
	float	m_fShininess;
	std::string	m_strName;
};

class CModel;	// CGroupŎgpCModelô߂̑O錾

class CGroup
{
public:
	std::string					m_strName;		// O[v
	std::vector<unsigned int>	m_vuiIndexIndexedTriangle;	// Op`ԍz
	CMaterial					m_material;		// }eA
	CModel*						m_pModel;			// fւ̃|C^
private:
	unsigned int				m_auiVboID[3];
public:
	CGroup( CModel* pModel )
	{
		m_pModel = pModel;
		memset( m_auiVboID, 0x00, 3 * sizeof( unsigned int ) );
	}
	virtual ~CGroup(){};
	unsigned int GetTriangleVertexVboID() { return m_auiVboID[0]; }
	unsigned int GetEdgeVertexIndexVboID() { return m_auiVboID[1]; }
	unsigned int GetTriangleVertexNormalVboID() { return m_auiVboID[2]; }
	void MakeVBO();
	void DestroyVBO();
};

class CModel
{
public:
	std::vector<CVector>			m_vVertex;				// _z
	std::vector<CVector>			m_vVectorVertexNormal;	// _@z
	std::vector<CIndexedTriangle>	m_vIndexedTriangle;		// Op`z
	std::vector<CGroup*>			m_vpGroup;				// O[vz
public:
	CModel(){}
	~CModel()
	{
		Clear();
	}
private:
	void Clear();
public:
	const CModel& operator = ( const CModel& model );
	void MakeVBO();
	void DestroyVBO();
};
